diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/attribute.h ns-3.43/src/core/model/attribute.h
--- ns-3.42/src/core/model/attribute.h	2024-05-29 15:29:46.928073200 -0700
+++ ns-3.43/src/core/model/attribute.h	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/attribute-helper.h ns-3.43/src/core/model/attribute-helper.h
--- ns-3.42/src/core/model/attribute-helper.h	2024-05-29 15:29:46.928073200 -0700
+++ ns-3.43/src/core/model/attribute-helper.h	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -204,7 +193,7 @@
     class name##Value : public AttributeValue                                                      \
     {                                                                                              \
       public:                                                                                      \
-        name##Value();                                                                             \
+        name##Value() = default;                                                                   \
         name##Value(const type& value);                                                            \
         void Set(const type& value);                                                               \
         type Get() const;                                                                          \
@@ -292,10 +281,6 @@
  * Typically invoked in the source file
  */
 #define ATTRIBUTE_VALUE_IMPLEMENT_WITH_NAME(type, name)                                            \
-    name##Value::name##Value()                                                                     \
-        : m_value()                                                                                \
-    {                                                                                              \
-    }                                                                                              \
     name##Value::name##Value(const type& value)                                                    \
         : m_value(value)                                                                           \
     {                                                                                              \
@@ -321,6 +306,11 @@
     bool name##Value::DeserializeFromString(std::string value,                                     \
                                             Ptr<const AttributeChecker> checker)                   \
     {                                                                                              \
+        if (value.empty())                                                                         \
+        {                                                                                          \
+            m_value = type();                                                                      \
+            return true;                                                                           \
+        }                                                                                          \
         std::istringstream iss;                                                                    \
         iss.str(value);                                                                            \
         iss >> m_value;                                                                            \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/boolean.cc ns-3.43/src/core/model/boolean.cc
--- ns-3.42/src/core/model/boolean.cc	2024-05-29 15:29:46.928073200 -0700
+++ ns-3.43/src/core/model/boolean.cc	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/boolean.h ns-3.43/src/core/model/boolean.h
--- ns-3.42/src/core/model/boolean.h	2024-05-29 15:29:46.928073200 -0700
+++ ns-3.43/src/core/model/boolean.h	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/breakpoint.cc ns-3.43/src/core/model/breakpoint.cc
--- ns-3.42/src/core/model/breakpoint.cc	2024-05-29 15:29:46.928073200 -0700
+++ ns-3.43/src/core/model/breakpoint.cc	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006,2007 INRIA, INESC Porto
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  * Author: Gustavo Carneiro <gjc@inescporto.pt>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/breakpoint.h ns-3.43/src/core/model/breakpoint.h
--- ns-3.42/src/core/model/breakpoint.h	2024-05-29 15:29:46.928073200 -0700
+++ ns-3.43/src/core/model/breakpoint.h	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006,2007 INESC Porto, INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Gustavo Carneiro <gjc@inescporto.pt>
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/build-profile.h ns-3.43/src/core/model/build-profile.h
--- ns-3.42/src/core/model/build-profile.h	2024-05-29 15:29:46.928073200 -0700
+++ ns-3.43/src/core/model/build-profile.h	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2015 LLNL
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/calendar-scheduler.cc ns-3.43/src/core/model/calendar-scheduler.cc
--- ns-3.42/src/core/model/calendar-scheduler.cc	2024-05-29 15:29:46.928073200 -0700
+++ ns-3.43/src/core/model/calendar-scheduler.cc	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  * Author: Alexander Krotov <krotov@iitp.ru>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/calendar-scheduler.h ns-3.43/src/core/model/calendar-scheduler.h
--- ns-3.42/src/core/model/calendar-scheduler.h	2024-05-29 15:29:46.928073200 -0700
+++ ns-3.43/src/core/model/calendar-scheduler.h	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  * Author: Alexander Krotov <krotov@iitp.ru>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/callback.cc ns-3.43/src/core/model/callback.cc
--- ns-3.42/src/core/model/callback.cc	2024-05-29 15:29:46.928073200 -0700
+++ ns-3.43/src/core/model/callback.cc	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -88,67 +77,3 @@
 ATTRIBUTE_CHECKER_IMPLEMENT(Callback);
 
 } // namespace ns3
-
-#if (__GNUC__ >= 3)
-
-#include <cstdlib>
-#include <cxxabi.h>
-
-namespace ns3
-{
-
-std::string
-CallbackImplBase::Demangle(const std::string& mangled)
-{
-    NS_LOG_FUNCTION(mangled);
-
-    int status;
-    char* demangled = abi::__cxa_demangle(mangled.c_str(), nullptr, nullptr, &status);
-
-    std::string ret;
-    if (status == 0)
-    {
-        NS_ASSERT(demangled);
-        ret = demangled;
-    }
-    else if (status == -1)
-    {
-        NS_LOG_UNCOND("Callback demangling failed: Memory allocation failure occurred.");
-        ret = mangled;
-    }
-    else if (status == -2)
-    {
-        NS_LOG_UNCOND("Callback demangling failed: Mangled name is not a valid under the C++ ABI "
-                      "mangling rules.");
-        ret = mangled;
-    }
-    else if (status == -3)
-    {
-        NS_LOG_UNCOND("Callback demangling failed: One of the arguments is invalid.");
-        ret = mangled;
-    }
-    else
-    {
-        NS_LOG_UNCOND("Callback demangling failed: status " << status);
-        ret = mangled;
-    }
-
-    if (demangled)
-    {
-        std::free(demangled);
-    }
-    return ret;
-}
-
-} // namespace ns3
-
-#else
-
-std::string
-ns3::CallbackImplBase::Demangle(const std::string& mangled)
-{
-    NS_LOG_FUNCTION(this << mangled);
-    return mangled;
-}
-
-#endif
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/callback.h ns-3.43/src/core/model/callback.h
--- ns-3.42/src/core/model/callback.h	2024-05-29 15:29:46.928073200 -0700
+++ ns-3.43/src/core/model/callback.h	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Stefano Avallone <stavallo@unina.it>
@@ -23,6 +12,7 @@
 
 #include "attribute-helper.h"
 #include "attribute.h"
+#include "demangle.h"
 #include "fatal-error.h"
 #include "ptr.h"
 #include "simple-ref-count.h"
@@ -100,12 +90,6 @@
 
   protected:
     /**
-     * \param [in] mangled The mangled string
-     * \return The demangled form of mangled
-     */
-    static std::string Demangle(const std::string& mangled);
-
-    /**
      * Helper to get the C++ typeid as a string.
      *
      * \tparam T \explicit The type of the argument.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/command-line.cc ns-3.43/src/core/model/command-line.cc
--- ns-3.42/src/core/model/command-line.cc	2024-05-29 15:29:46.928073200 -0700
+++ ns-3.43/src/core/model/command-line.cc	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/command-line.h ns-3.43/src/core/model/command-line.h
--- ns-3.42/src/core/model/command-line.h	2024-05-29 15:29:46.932073000 -0700
+++ ns-3.43/src/core/model/command-line.h	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -466,7 +455,7 @@
 
     /**
      * \ingroup commandline
-     *\brief An argument Item assigning to POD
+     * \brief An argument Item assigning to POD
      */
     template <typename T>
     class UserItem : public Item
@@ -672,8 +661,9 @@
 
 }; // class CommandLine
 
-/** \ingroup commandline
- *  \defgroup commandlinehelper Helpers to specialize UserItem
+/**
+ * \ingroup commandline
+ * \defgroup commandlinehelper Helpers to specialize UserItem
  */
 /**
  * \ingroup commandlinehelper
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/config.cc ns-3.43/src/core/model/config.cc
--- ns-3.42/src/core/model/config.cc	2024-05-29 15:29:46.932073000 -0700
+++ ns-3.43/src/core/model/config.cc	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/config.h ns-3.43/src/core/model/config.h
--- ns-3.42/src/core/model/config.h	2024-05-29 15:29:46.932073000 -0700
+++ ns-3.43/src/core/model/config.h	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/default-deleter.h ns-3.43/src/core/model/default-deleter.h
--- ns-3.42/src/core/model/default-deleter.h	2024-05-29 15:29:46.932073000 -0700
+++ ns-3.43/src/core/model/default-deleter.h	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2010 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/default-simulator-impl.cc ns-3.43/src/core/model/default-simulator-impl.cc
--- ns-3.42/src/core/model/default-simulator-impl.cc	2024-05-29 15:29:46.932073000 -0700
+++ ns-3.43/src/core/model/default-simulator-impl.cc	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/default-simulator-impl.h ns-3.43/src/core/model/default-simulator-impl.h
--- ns-3.42/src/core/model/default-simulator-impl.h	2024-05-29 15:29:46.932073000 -0700
+++ ns-3.43/src/core/model/default-simulator-impl.h	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/demangle.cc ns-3.43/src/core/model/demangle.cc
--- ns-3.42/src/core/model/demangle.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.43/src/core/model/demangle.cc	2024-10-09 16:41:09.856655800 -0700
@@ -0,0 +1,75 @@
+/*
+ * Copyright (c) 2005,2006 INRIA
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ * Modified by: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+ *              Moved the Demangle function out of CallbackImplBase
+ */
+
+#include "demangle.h"
+
+#include "assert.h"
+#include "log.h"
+
+NS_LOG_COMPONENT_DEFINE("Demangle");
+
+#if (__GNUC__ >= 3)
+
+#include <cstdlib>
+#include <cxxabi.h>
+
+std::string
+ns3::Demangle(const std::string& mangled)
+{
+    NS_LOG_FUNCTION(mangled);
+
+    int status;
+    char* demangled = abi::__cxa_demangle(mangled.c_str(), nullptr, nullptr, &status);
+
+    std::string ret;
+    if (status == 0)
+    {
+        NS_ASSERT(demangled);
+        ret = demangled;
+    }
+    else if (status == -1)
+    {
+        NS_LOG_DEBUG("Demangling failed: Memory allocation failure occurred.");
+        ret = mangled;
+    }
+    else if (status == -2)
+    {
+        NS_LOG_DEBUG("Demangling failed: Mangled name is not a valid under the C++ ABI "
+                     "mangling rules.");
+        ret = mangled;
+    }
+    else if (status == -3)
+    {
+        NS_LOG_DEBUG("Demangling failed: One of the arguments is invalid.");
+        ret = mangled;
+    }
+    else
+    {
+        NS_LOG_DEBUG("Demangling failed: status " << status);
+        ret = mangled;
+    }
+
+    if (demangled)
+    {
+        std::free(demangled);
+    }
+    return ret;
+}
+
+#else
+
+std::string
+ns3::Demangle(const std::string& mangled)
+{
+    NS_LOG_FUNCTION(mangled);
+    return mangled;
+}
+
+#endif
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/demangle.h ns-3.43/src/core/model/demangle.h
--- ns-3.42/src/core/model/demangle.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.43/src/core/model/demangle.h	2024-10-09 16:41:09.856655800 -0700
@@ -0,0 +1,25 @@
+/*
+ * Copyright (c) 2005,2006 INRIA
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ * Modified by: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+ *              Moved the Demangle function out of CallbackImplBase
+ */
+
+#ifndef NS3_DEMANGLE_H
+#define NS3_DEMANGLE_H
+
+#include <string>
+
+namespace ns3
+{
+/**
+ * \param [in] mangled The mangled string
+ * \return The demangled form of mangled
+ */
+std::string Demangle(const std::string& mangled);
+}; // namespace ns3
+
+#endif // NS3_DEMANGLE_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/deprecated.h ns-3.43/src/core/model/deprecated.h
--- ns-3.42/src/core/model/deprecated.h	2024-05-29 15:29:46.932073000 -0700
+++ ns-3.43/src/core/model/deprecated.h	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -92,7 +81,14 @@
  * \param msg Optional message to add to the compiler warning.
  *
  */
-#define NS_DEPRECATED(msg) [[deprecated(msg)]]
+#define NS_DEPRECATED(msg) /** \deprecated msg */ [[deprecated(msg)]]
+
+/**
+ * \ingroup deprecation
+ * \def NS_DEPRECATED_3_43
+ * Tag for things deprecated in version ns-3.43.
+ */
+#define NS_DEPRECATED_3_43(msg) NS_DEPRECATED("Deprecated in ns-3.43: " msg)
 
 /**
  * \ingroup deprecation
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/des-metrics.cc ns-3.43/src/core/model/des-metrics.cc
--- ns-3.42/src/core/model/des-metrics.cc	2024-05-29 15:29:46.932073000 -0700
+++ ns-3.43/src/core/model/des-metrics.cc	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 LLNL
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/core/model/des-metrics.h ns-3.43/src/core/model/des-metrics.h
--- ns-3.42/src/core/model/des-metrics.h	2024-05-29 15:29:46.932073000 -0700
+++ ns-3.43/src/core/model/des-metrics.h	2024-10-09 16:41:09.856655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 LLNL
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
  */
